; Funkce InstallPlcFiles obsahuje instrukce pro koprovan soubor projektu na dc
; systm. V prbhu instalace je na dc systm poteba penst vechny vyadovan
; soubory. Vtina soubor se kopruje do strojnho adrese a pi odinstalaci se zase 
; odeberou (pi odinstalaci se mus odebrat ve ze strojnho adrese). Nkter soubory 
; se kopruj do uivatelskho adrese - jedn se o soubory, kter jsou jedinen pro
; dan stroj (nikoliv pro typ stroje) a pi odinstalaci se proto neodstrauj. Pi
; instalaci se kopruj jen tehdy, pokud v uivatelskm adresi jet nejsou (pokud
; tam ji jsou, nesm se pepsat - na rozdl od soubor ve strojnm adresi se nesm
; pepsat pi aktualizaci PLC novj verz).

Function InstallPlcFiles

	; Koprovn soubor do strojnho adrese
		; Podadres Config
	File	"/oname=Config\Channel0.ChannelConfig"				"$%ProjectDir%\Config\Channel0.ChannelConfig"
	File	"/oname=Config\TechnologyArea.KbdConfig"			"$%ProjectDir%\Config\TechnologyArea.KbdConfig"
	File	"/oname=Config\KnobArea.KbdConfig"			        "$%ProjectDir%\Config\KnobArea.KbdConfig"
	; Vytvoit podadres Html\Macro
	CreateDirectory "$CNCMACHINEFILES_FOLDER\Html\Macro"
	CreateDirectory "$CNCMACHINEFILES_FOLDER\Html\Macro\Lathe"

		; Podadres Html	
	File	"/oname=Html\Top.html"								"$%ProjectDir%\Html\Top.html"
	File	"/oname=Html\Main.html"								"$%ProjectDir%\Html\Main.html"
	File	"/oname=Html\Tools.html"							"$%ProjectDir%\Html\Tools.html"
	File	"/oname=Html\SetLengthX.html"						"$%ProjectDir%\Html\SetLengthX.html"
	File	"/oname=Html\SetLengthZ.html"						"$%ProjectDir%\Html\SetLengthZ.html"
	File	"/oname=Html\ModifLengthX.html"						"$%ProjectDir%\Html\ModifLengthX.html"
	File	"/oname=Html\ModifLengthZ.html"						"$%ProjectDir%\Html\ModifLengthZ.html"
	File	"/oname=Html\TableOffs.html"						"$%ProjectDir%\Html\TableOffs.html"
	File	"/oname=Html\Macro\ClearAx.html"					"$%ProjectDir%\Html\Macro\ClearAx.html"
	File	"/oname=Html\Macro\SetAx.html"						"$%ProjectDir%\Html\Macro\SetAx.html"
	File	"/oname=Html\Macro\Lathe\ManBlock.html"				"$%ProjectDir%\Html\Macro\Lathe\ManBlock.html"
	File	"/oname=Html\LatheToolType.png"						"$%ProjectDir%\Html\LatheToolType.png"
	File	"/oname=Html\LatheAxisDirection.png"			    "$%ProjectDir%\Html\LatheAxisDirection.png"

		; Podadres Include
	File	"/oname=Include\Lathe.nch"							"$%ProjectDir%\Include\Lathe.nch"
		; Podadres MAC	
	File	"/oname=MAC\Lathe.ncp"								"$%ProjectDir%\MAC\Lathe.ncp"
		; Podadres PLC
	File	"/oname=Plc\Commands.PlcConstants"					"$%ProjectDir%\Plc\Commands.PlcConstants"
	File	"/oname=Plc\SAVars.PlcConstants"					"$%ProjectDir%\Plc\SAVars.PlcConstants"
	File	"/oname=Plc\Plc.PlcErrors"							"$%ProjectDir%\Plc\Plc.PlcErrors"
		; Podadres PriorityBlock
	File	"/oname=PriorityBlock\PriorityBlock.ncp"			"$%ProjectDir%\PriorityBlock\PriorityBlock.ncp"
		; Podadres SoftMenu
	File	"/oname=SoftMenu\Technology.SoftMenu"				"$%ProjectDir%\SoftMenu\Technology.SoftMenu"
	File	"/oname=SoftMenu\ReferenceCSY.SoftMenu"				"$%ProjectDir%\SoftMenu\ReferenceCSY.SoftMenu"
	File	"/oname=SoftMenu\MainCSY.SoftMenu"					"$%ProjectDir%\SoftMenu\MainCSY.SoftMenu"
		; Podadres Tab
	File	"/oname=Tab\Tools.PlcTDef"							"$%ProjectDir%\Tab\Tools.PlcTDef"
	
	; Koprovn soubor do uivatelskho adrese (soubory se kopruj podmnn pouze
	; pokud tam jet nejsou)
		;Podadres Tab
	IfFileExists "$CNCUSERFILES_FOLDER\Tab\Tools.PlcT" +2 0
		File	"/oname=$CNCUSERFILES_FOLDER\Tab\Tools.PlcT"	"$%ProjectDir%\Tab\Tools.PlcT"
FunctionEnd




; Funkce un.InstallPlcFiles obsahuje instrukce pro odstrann soubor projektu z dcho
; systmu. Funkce se vol v prbhu odinstalace a mus odstranit vechny soubory, kter
; se na dc systm nakoprovaly v prbhu instalace (volnm funkce InstallPlcFiles).
; Funkce neodstran soubory zkoprovan pi instalaci do uivatelskho adrese.

Function un.InstallPlcFiles

	; Odstrann soubor ze strojnho adrese
		; Podadres Config
	Delete	"$INSTDIR\Config\Channel0.ChannelConfig"	
	Delete	"$INSTDIR\Config\TechnologyArea.KbdConfig"
	Delete	"$INSTDIR\Config\KnobArea.KbdConfig"
		; Podadres Html
	Delete	"$INSTDIR\Html\Top.html"
	Delete	"$INSTDIR\Html\Main.html"
	Delete	"$INSTDIR\Html\Tools.html"
	Delete	"$INSTDIR\Html\SetLengthX.html"
	Delete	"$INSTDIR\Html\SetLengthZ.html"
	Delete	"$INSTDIR\Html\ModifLengthX.html"
	Delete	"$INSTDIR\Html\ModifLengthZ.html"
	Delete	"$INSTDIR\Html\TableOffs.html"
	Delete	"$INSTDIR\Html\Macro\ClearAx.html"
	Delete	"$INSTDIR\Html\Macro\SetAx.html"
	Delete	"$INSTDIR\Html\Macro\Lathe\ManBlock.html"
	Delete	"$INSTDIR\Html\LatheToolType.png"
	Delete  "$INSTDIR\Html\LatheAxisDirection.png"
		; Podadres Include
	Delete	"$INSTDIR\Include\Lathe.nch"
		; Podadres MAC
	Delete	"$INSTDIR\MAC\Lathe.ncp"
		; Podadres PLC
	Delete	"$INSTDIR\Plc\Commands.PlcConstants"
	Delete	"$INSTDIR\Plc\SAVars.PlcConstants"
	Delete	"$INSTDIR\Plc\Plc.PlcErrors"
		; Podadres PriorityBlock
	Delete	"$INSTDIR\PriorityBlock\PriorityBlock.ncp"
		; Podadres SoftMenu
	Delete	"$INSTDIR\SoftMenu\Technology.SoftMenu"
	Delete	"$INSTDIR\SoftMenu\ReferenceCSY.SoftMenu"
	Delete	"$INSTDIR\SoftMenu\MainCSY.SoftMenu"
		; Podadres Tab
	Delete	"$INSTDIR\Tab\Tools.PlcTDef"
		; Odstrann przdnch podadres 	
	RMDir	"$INSTDIR\Html\Macro\Lathe"
	RMDir	"$INSTDIR\Html\Macro"

FunctionEnd



; Funkce InstallPlcCpnfig obsahuje instrukce pro vytvoen poloek konfigurace v registru Windows.
; Jednotliv poloky se zapisuj do sekce registru "HKLM\Software\MEFI\WinCNC\Machine", tj. do
; sti konfigurace vyhrazen pro stroj.
Function InstallPlcConfig
	; ********** Machine/Channels/Channel0 **********
	${registry::Write} "HKLM\Software\MEFI\WinCNC\Machine\Channels\Channel0\PartProg"	"AdditionalInlFiles"	"Lathe.nch$\n"	"REG_MULTI_SZ" $R0
	${registry::Write} "HKLM\Software\MEFI\WinCNC\Machine\Channels\Channel0\PartProg"	"AdditionalMacFiles"	"Lathe.ncp$\n"	"REG_MULTI_SZ" $R0
	${registry::Write} "HKLM\Software\MEFI\WinCNC\Machine\Channels\Channel0\Keyboards\Keyboard4" "ConfigFiles" "KnobArea.KbdConfig" "REG_MULTI_SZ" $R0
	; ********** Machine/PLC **********
	${registry::Write} "HKLM\Software\MEFI\WinCNC\Machine\PLC" "AdditionalPlcConstants"	"Commands.PlcConstants$\nSAVars.PlcConstants$\n"	"REG_MULTI_SZ" $R0
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\PLC\Tables" "PlcTableDef0"	"Tools.PlcTDef"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\PLC\Tables" "PlcTable0"		"Tools.PlcT"


	; ********** Install/UserInterface **********
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default" "WindowsCount"	5
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default" "Category"		"Default"
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default" "Name"			"Vchoz formt"
	
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window0" "DefaultWindow"	"Main"
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window0" "Left"			0
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window0" "Top"				0
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window0" "Right"			50
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window0" "Bottom"			30
		
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window1" "DefaultWindow"	"MDI"
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window1" "Left"			0
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window1" "Top"				31
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window1" "Right"			50
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window1" "Bottom"			84
		
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window2" "DefaultWindow"	"StatusBar"
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window2" "Left"			0
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window2" "Top"				85
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window2" "Right"			50
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window2" "Bottom"			89
		
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window3" "DefaultWindow"	"SimplePersistentErrors"
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window3" "Left"			0
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window3" "Top"				90
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window3" "Right"			50
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window3" "Bottom"			100
		
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window4" "DefaultWindow"	"NcpPreview"
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window4" "Left"			50
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window4" "Top"				0
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window4" "Right"			100
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Layouts\Default\Window4" "Bottom"			100

	; ***** Reference na tlacitka
	; ID_CNC_SELECTREF0
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Commands\ID_CNC_SELECTREF0" "Htmlfile" ""
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Commands\ID_CNC_SELECTREF0" "Reftype" "SingleAxis"
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Commands\ID_CNC_SELECTREF0" "RefNo" 0

	; ID_CNC_SELECTREF1
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Commands\ID_CNC_SELECTREF1" "Htmlfile" ""
	WriteRegStr			HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Commands\ID_CNC_SELECTREF1" "Reftype" "SingleAxis"
	WriteRegDWORD		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Commands\ID_CNC_SELECTREF1" "RefNo" 1

	; ***** Machine/UserInterface/Dialogs
	
		; Tools
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\Tools" "Library"		"StdPlugins"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\Tools" "Type"			"PlcTableEditor"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\Tools" "HtmlFile"		"Tools.html"
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\Tools" "PlcTableNo"	0


	; ***** Machine/UserInterface/Dialogs
		; SetLengthX
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthX" "Library"		"WinCNC"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthX" "Type"			"MacroDialog"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthX" "HtmlFile"		"SetLengthX.html"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthX" "SoftMenuFile"	"WndMacroDialogAxConfig.SoftMenu"

		; SetLengthZ
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthZ" "Library"		"WinCNC"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthZ" "Type"			"MacroDialog"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthZ" "HtmlFile"		"SetLengthZ.html"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\SetLengthZ" "SoftMenuFile"	"WndMacroDialogAxConfig.SoftMenu"

		; ModifLengthX
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthX" "Library"		"WinCNC"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthX" "Type"			"MacroDialog"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthX" "HtmlFile"		"ModifLengthX.html"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthX" "SoftMenuFile"	"WndMacroDialogAxConfig.SoftMenu"

		; ModifLengthZ
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthZ" "Library"		"WinCNC"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthZ" "Type"			"MacroDialog"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthZ" "HtmlFile"		"ModifLengthZ.html"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Dialogs\ModifLengthZ" "SoftMenuFile"	"WndMacroDialogAxConfig.SoftMenu"





	
	; ***** Machine/UserInterface/Windows
		; NcpPreview
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "Library"				"StdPlugins"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "Type"					"NcpPreview"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "Category"				"Standardn"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "Name"					"Nhled partprogramu"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "Plane"				"ZX"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "ViewedSpace"			"Pos1"
	WriteRegStr		HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "ViewType"				"Plane"
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "PlaneZXAngleX"		90
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "PlaneZXAngleY"		180
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "PlaneZXAngleZ"		90
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "ViewBtnAxonometry"	0
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "ViewBtnPerspective"	0
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "ViewBtnPlane"			0
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "ViewBtnRotate"		0
	WriteRegDWORD	HKLM "Software\MEFI\WinCNC\Machine\UserInterface\Windows\NcpPreview" "ViewBtnSelPlane"		0
FunctionEnd



; Funkce un.Install PlcFiles se vol v prbhu odinstalace a jejm kolem je odstrann 
; konfiguranch poloek z registru Windows. V rmci tto funkce vak nen poteba
; odstraovat poloky ze sekce "HKLM\Software\MEFI\WinCNC\Machine", nebo ta se v prbhu
; odinstalace odstran cel.
Function un.InstallPlcConfig
FunctionEnd
